﻿using System;

using Microsoft.SPOT;
using Microsoft.SPOT.Input;
using Microsoft.SPOT.Presentation;
using Microsoft.SPOT.Presentation.Controls;

namespace UIDemo_Presentation
{
    public class Program : Microsoft.SPOT.Application
    {
        public static void Main()
        {
            Program myApplication = new Program();

            Window mainWindow = myApplication.CreateWindow();

            // Crea l'oggetto che mappa i GPIO come ingressi di tipo "Button"
            GPIOButtonInputProvider inputProvider = new GPIOButtonInputProvider(null);

            // Avvia l'applicazione a partire dalla finestra appena creata
            myApplication.Run(mainWindow);
        }

        public Window CreateWindow()
        {
            Window wnd;

            // Creazione di una finstra con le stesse dimensioni del display
            wnd = new Window();
            wnd.Height = SystemMetrics.ScreenHeight;
            wnd.Width = SystemMetrics.ScreenWidth;

            // Creazione di un oggetto di tipo Text
            Text text = new Text();

            text.Font = Resources.GetFont(Resources.FontResources.small);
            text.TextContent = Resources.GetString(Resources.StringResources.String1);
            text.HorizontalAlignment = Microsoft.SPOT.Presentation.HorizontalAlignment.Center;
            text.VerticalAlignment = Microsoft.SPOT.Presentation.VerticalAlignment.Center;

            // Aggiunta dell'oggetto Text alla gerarchia della finestra
            wnd.Child = text;

            // Aggiunta di un gestore di evento per l'evento ButtonUp
            wnd.AddHandler(Buttons.ButtonUpEvent, new ButtonEventHandler(OnButtonUp), false);

            // La finestra viene effettivamente mostrata
            wnd.Visibility = Visibility.Visible;

            // L'input di tipo "Button" viene ridirezionato su questa finestra
            Buttons.Focus(wnd);

            return wnd;
        }

        private void OnButtonUp(object sender, ButtonEventArgs e)
        {
            // Visualizza il codice del pulsante nella finestra di debug
            Debug.Print(e.Button.ToString());
        }
    }
}
